

#ifndef ENVIRON_H
#define ENVIRON_H

#include "types.h"
#include "vector.h"
#include <GL/glut.h>
#include "gts.h"

static const int ENVIRON_XYZ = 1;
static const int ENVIRON_SINX = 2;
static const int ENVIRON_SINXSINZ = 3;
static const int ENVIRON_SINXXZZ = 4;

class Environ {

public:
	Environ() {makeEnvironGlList();}
	static const GLuint ENVIRON_GLLIST_NUM = 1;

	FLT inside(const Vector3& location) const;
	Vector3 gradient(const Vector3& location) const;
	void project(Vector3& point) const;
	void glVisualize() const;
	static void gtsFunction(gdouble ** f, GtsCartesianGrid g, guint k, gpointer env);
	
private:

	static const FLT maxgrad;	
	void makeEnvironGlList();
	

};


#endif
