
#ifndef LISTS_H
#define LISTS_H

#include <vector>
#include <list>
#include "vector.h"
#include "spring.h"
#include "masspoint.h"

extern MassPoint* surfacepoints;
extern MassPoint* innerpoints;

extern int Nsurfacepoints;
extern int Ninnerpoints;

extern Spring* springs;
extern int Nsprings;


class PointList {

public:
/*
	PointList(): index() {}	
	
	int add(MassPoint* v) {
		index.push_back(v);
		return index.size()-1;	
	}
	
	Vector3& get(unsigned int i) {return *index[i];}
	MassPoint& getMP(unsigned int i) {return *index[i];}
	
	unsigned int size() {return index.size();}
*/	
	
	static void updateAllPositions(FLT dt) {
		
		for(unsigned int i = 0; i< Nsurfacepoints; i++) {		
			surfacepoints[i].updatePosition(dt);
		}
		for(unsigned int i = 0; i< Ninnerpoints; i++) {		
			innerpoints[i].updatePosition(dt);
		}		
	
	}
	
	static void setExternalForces() {

		for(unsigned int i = 0; i< Nsurfacepoints; i++) {		
			surfacepoints[i].setForcesToGlobal();
		}
		for(unsigned int i = 0; i< Ninnerpoints; i++) {		
			innerpoints[i].setForcesToGlobal();
		}		
	
	}
	
	static void updateAllVelocities(FLT dt) {

		for(unsigned int i = 0; i< Nsurfacepoints; i++) {		
			surfacepoints[i].updateVelocity(dt);
		}
		for(unsigned int i = 0; i< Ninnerpoints; i++) {		
			innerpoints[i].updateVelocity(dt);
		}		
		
	
	}
		
	static void debug();
	
};



class SpringList {

/*
public:
	SpringList(): list() {}
	
	void registerSpring(Spring* s) {
		list.push_back(s); 

	}
*/	
public:
	static void generateSpringForces() {

		for(unsigned int i = 0; i<Nsprings; i++) {				
			springs[i].setForces();
		}	
	
	}
	
};


/*
class ConnectivityList {

public:

	typedef struct {
		int i[3];	
	} int3;

public:
	ConnectivityList(): index() {}	

	int add(int i1,int i2,int i3) {
		
		int3 i;
		i.i[0]=i1; i.i[1]=i2; i.i[2]=i3;
		index.push_back(i);
		return index.size()-1;	
	}

	void get(unsigned int i, int3& ret) { ret = index[i];}
	
	unsigned int size() {return index.size();}

private:
	std::vector<int3> index;

};
*/
#endif
