
#ifndef MASSPOINT_H
#define MASSPOINT_H

#include "vector.h"
#include<list>

class Spring;

class MassPoint: public Vector3 {

	friend class Spring;
	
private:
	MassPoint(const MassPoint&);
//	MassPoint& operator=(const MassPoint&);

public:

	MassPoint() {};

	MassPoint(DBL x, DBL y, DBL z, FLT mass): Vector3(x,y,z), m(mass), v(0), f(0)//, s() 
		{}
	MassPoint(const Vector3& l, FLT mass): Vector3(l), m(mass), v(0), f(0)//, s() 
		{}		

	void connectSpring(Spring* spring) {
//		s.push_back(spring);
	}
	
	void updatePosition(FLT dt) {	
		add(v.scaled(dt));
	}
	
	void setForcesToGlobal() {	
//		std::cout << " p = " << this << " f = " << f << std::endl;
		f = Vector3(0,-9.81,0).scaled(m); // g in -z richtung fr den moment!

	}	
	
	void updateVelocity(FLT dt) {
		
//		v.add( Vector3::sub( f,v.scaled(0.001).scaled(m) ).scaled(dt/m) ); 
		v.add( f.scaled(dt/m) ); 
//		if (v.length() < 0.1) v = Vector3(0);
	}
	
	void debug();

	
public:
	Vector3 v; // geschw.	
private:
	Vector3 f; // kraft	
private:
	float m; // masse


};

#endif
