
#ifndef OBJECT_H
#define OBJECT_H


#include "vector.h"
#include "masspoint.h"
#include "spring.h"

extern MassPoint* surfacepoints;
extern MassPoint* innerpoints;

extern int Nsurfacepoints;
extern int Ninnerpoints;

extern Spring* springs;
extern int Nsprings;

class Environ;

class Object {

public:
	Object(const Environ& e): env(e) {}
	
	virtual ~Object();
	
	void simulate(FLT dt);
	void initSimulation(FLT dt);	
	void setV(const Vector3& v);
	
	virtual void glVisualize(int) = 0;
	
protected:
	const Environ& env;

};

#endif
