#include "spring.h"
extern MassPoint* surfacepoints;
extern MassPoint* innerpoints;

extern int Nsurfacepoints;
extern int Ninnerpoints;

extern Spring* springs;
extern int Nsprings;

extern int* connectivity;
extern int Nconnectivity;

int inelastic_springs = 0;

Spring::Spring(/*MassPoint* mp1, MassPoint* mp2,*/
		int mp1, int mp2,
		 FLT stiffness):
	p1(&surfacepoints[mp1]), p2(&surfacepoints[mp2]), stiff(stiffness) 
{
	
	li = ( Vector3::sub(*p1,*p2).length() );
	lc = li;
			
	p1->connectSpring(this);
	p2->connectSpring(this);
	
}

void Spring::setForces() {

	Vector3 f1 = Vector3::sub(*p1,*p2);
	lc = f1.length();

	// damping
	Vector3 dv = Vector3::sub(p1->v,p2->v);
	FLT damp = Vector3::dotProd(dv,f1)/lc;
	
	FLT d = (lc - li) / lc;
	f1.scale(stiff*d+damp*6);
	
	if (inelastic_springs==1 && f1.length() > 60) li = 0.99*li + 0.01*lc;
//	if (d > 0.001) li = 0.99*li + 0.01*lc;
	
	// f1: Kraft in p1, Kraft in p2 = -f1
	p2->f.add(f1);
	p1->f.sub(f1);
	
}
